#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 500, MAXW = 1000000000;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc >= 4);

    int k = atoi(argv[1]);
    int n = atoi(argv[2]);
    int shift = atoi(argv[3]);

    cout << n << " " << k << "\n";
    
    set<pair<pii, pii>> have;
    int from = max(1, (abs(shift) + 2) / 2);
    int cnt = from;
    for (int i = 0; i < n; ++i) {
        while (true) {
            int type = rnd.next(0, 3);
            // 2 * lvl - 1 >= shift
            // 2 * lvl >= shift + 1
            // lvl >= (shift + 1) / 2
            int lvl = rnd.next(max(1, (abs(shift) + 2) / 2), k);
            if (n >= k - from + 1 && cnt <= k) {
                lvl = cnt++;
            }
            int from = rnd.next(max(0, 1 - shift), (int) min((ll) 2 * lvl - 1 - shift, (ll) 2 * lvl));
            pair<pii, pii> e;
            if (type == 0) {
                e = {{lvl, from - lvl}, {lvl - 1, from - lvl + shift}};
            } else if (type == 1) {
                e = {{lvl - from, lvl}, {lvl - from - shift, lvl - 1}};
            } else if (type == 2) {
                e = {{-lvl, lvl - from}, {-lvl + 1, lvl - from - shift}};
            } else {
                e = {{from - lvl, -lvl}, {from - lvl + shift, -lvl + 1}};
            }         
            if (!have.count(e)) {
                have.insert(e);
                if (rnd.next(0, 1)) {
                    swap(e.ff, e.ss);
                }
                cout << e.ff.ff << " " << e.ff.ss << " " << e.ss.ff << " " << e.ss.ss << "\n";
                break;
            }
            
        }
    }

    int xa = rnd.next(max(1, (abs(shift) + 2) / 2) - 1, k) * (rnd.next(0, 1) * 2 - 1);
    int ya = rnd.next(max(1, (abs(shift) + 2) / 2) - 1, k) * (rnd.next(0, 1) * 2 - 1);
    int xb = rnd.next(max(1, (abs(shift) + 2) / 2) - 1, k) * (rnd.next(0, 1) * 2 - 1);
    int yb = rnd.next(max(1, (abs(shift) + 2) / 2) - 1, k) * (rnd.next(0, 1) * 2 - 1);


    cout << xa << " " << ya << " " << xb << " " << yb << "\n";

    return 0;
}