#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

ll sqr(ll num) {
    return num * num;
}


int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    ios::sync_with_stdio(false);
    
    int n, k;
    cin >> n >> k;
    map<int, vector<pii>> here;
    set<pii> inp;
    vector<pair<pii, pii>> edges;
    for (int i = 0; i < n; ++i) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        inp.insert({x1, y1});
        inp.insert({x2, y2});
        edges.puba({{x1, y1}, {x2, y2}});
        here[max(abs(x1), abs(y1))].puba({x1, y1});
        here[max(abs(x2), abs(y2))].puba({x2, y2});
    }

    int xa, ya, xb, yb;
    cin >> xa >> ya >> xb >> yb;
    inp.insert({xa, ya});
    inp.insert({xb, yb});
    if (max(xa, ya) > k || max(xb, yb) > k) {
        cout << "-1\n";
        return 0;
    }
    
    here[max(abs(xa), abs(ya))].puba({xa, ya});
    here[max(abs(xb), abs(yb))].puba({xb, yb});

    vector<vector<pair<int, double>>> graph;
    map<pii, int> inds;

    for (auto& p : here) {
        //cerr << "layer: " << p.ff << endl;
        auto& v = p.ss;
        v.puba({p.ff, p.ff});
        v.puba({p.ff, -p.ff});
        v.puba({-p.ff, p.ff});
        v.puba({-p.ff, -p.ff});
        sort(bend(v));
        v.erase(unique(bend(v)), v.end());
        sort(bend(v), [&](pii a, pii b) {
            int va = 0;
            if (a.ss == p.ff) {
                va = 1;
            } else if (a.ff == -p.ff) {
                va = 2;
            } else if (a.ss == -p.ff) {
                va = 3;
            }
            
            int vb = 0;
            if (b.ss == p.ff) {
                vb = 1;
            } else if (b.ff == -p.ff) {
                vb = 2;
            } else if (b.ss == -p.ff) {
                vb = 3;
            }

            if (va != vb) {
                return va < vb;
            }

            if (va == 0) {
                return a.ss < b.ss;
            }
            if (va == 1) {
                return a.ff > b.ff;
            }
            if (va == 2) {
                return a.ss > b.ss;
            }
            return a.ff < b.ff;
        });

        /*
        for (pii pp : v) {
            cerr << pp.ff << " " << pp.ss << endl;
        }
        cerr << endl;
        */
        int from = szof(graph);
        //graph.resize(szof(graph) + szof(v));

        double sum = 0;
        double cur = 0;
        bool found = false;
        for (int i = 0; i < szof(v); ++i) {
            if (inp.count(v[i])) {
                inds[v[i]] = szof(graph);
                //cerr << "point " << v[i].ff << " " << v[i].ss << endl;
                //cerr << cur << endl;
                if (found) {
                    graph.back().puba({szof(graph), cur});
                    graph.puba({{szof(graph) - 1, cur}});
                } else {
                    graph.puba({});
                    sum = 0;
                }
                cur = 0;
                found = true;
            }
            int next = (i + 1) % szof(v);
            int dist = abs(v[i].ff - v[next].ff) + abs(v[i].ss - v[next].ss);
            sum += dist;
            cur += dist;
            //cerr << "+= " << dist << endl;
        }
        sum -= cur;
        if (from < szof(graph) - 1) {
            //cerr << 4.0 * p.ff * 2 - sum << endl;
            graph[from].puba({szof(graph) - 1, 4.0 * p.ff * 2 - sum});
            graph.back().puba({from, 4.0 * p.ff * 2 - sum});
        }
    }

    for (auto e : edges) {
        int ind1 = inds[e.ff], ind2 = inds[e.ss];
        double dist = sqrt(sqr(e.ff.ff - e.ss.ff) + sqr(e.ff.ss - e.ss.ss));
        graph[ind1].puba({ind2, dist});
        graph[ind2].puba({ind1, dist});
    }

    int s = inds[{xa, ya}];
    int t = inds[{xb, yb}];

    vector<double> dist(szof(graph), 1e100);
    set<pair<double, int>> st;
    dist[s] = 0;
    st.insert({0, s});
    
    while (szof(st)) {
        int v = st.begin()->ss;
        st.erase(st.begin());
        if (v == t) {
            break;
        }
        for (auto to : graph[v]) {
            if (dist[to.ff] > dist[v] + to.ss) {
                st.erase({dist[to.ff], to.ff});
                dist[to.ff] = dist[v] + to.ss;
                st.insert({dist[to.ff], to.ff});
            }
        }
    }

    if (dist[t] > 1e50) {
        cout << "-1\n";
    } else {
        cout << dist[t] << "\n";
    }

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}