#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

int m;
string s;
map<tuple<int, int, int>, string> f1_mem;

string f1_sol(int l, int r, int q) {
    return f1_mem[make_tuple(l, r, q)];
}

bool f1(int l, int r, int q) {
    if (f1_mem.count(make_tuple(l, r, q))) {
        return szof(f1_mem[make_tuple(l, r, q)]);
    }
    auto& res = f1_mem[make_tuple(l, r, q)];
    int num = 0;
    for (int i = l; i < r; ++i) {
        num = (num * 10 + s[i] - '0') % m;
    }
    if (num == q) {
        res = s.substr(l, r - l);
        return 1;
    }
    for (int i = l; i < r - 1; ++i) {
        for (int j = 0; j < m; ++j) {
            if (f1(l, i + 1, j) && f1(i + 1, r, (q - j + m) % m)) {
                res = f1_sol(l, i + 1, j) + "+" + f1_sol(i + 1, r, (q - j + m) % m);
                return 1;
            }
        }
    }
    return 0;
}

map<tuple<int, int, int>, string> f3_mem;
vector<vector<pii>> allp;

string f3_sol(int l, int r, int q) {
    return f3_mem[make_tuple(l, r, q)];
}

bool f3(int l, int r, int q) {
    if (f3_mem.count(make_tuple(l, r, q))) {
        return szof(f3_mem[make_tuple(l, r, q)]);
    }
    auto& res = f3_mem[make_tuple(l, r, q)];
    int num = 0;
    for (int i = l; i < r; ++i) {
        num = (num * 10 + s[i] - '0') % m;
    }
    if (num == q) {
        res = s.substr(l, r - l);
        return 1;
    }
    
    for (int i = l; i < r - 1; ++i) {
        for (pii jk : allp[q]) {
            if (f3(l, i + 1, jk.ff) && f3(i + 1, r, jk.ss)) {
                res = f3_sol(l, i + 1, jk.ff) + "*" + f3_sol(i + 1, r, jk.ss);
                return 1;
            }
        }
    }
    return 0;
}

map<tuple<int, int, int>, string> f2_mem;

string f2_sol(int l, int r, int q) {
    return f2_mem[make_tuple(l, r, q)];
}

bool f2(int l, int r, int q) {
    if (f2_mem.count(make_tuple(l, r, q))) {
        return szof(f2_mem[make_tuple(l, r, q)]);
    }
    auto& res = f2_mem[make_tuple(l, r, q)];
    if (f3(l, r, q)) {
        res = f3_sol(l, r, q);
        return 1;
    }
    for (int i = l; i < r - 1; ++i) {
        for (int j = 0; j < m; ++j) {
            if (f2(l, i + 1, j) && f2(i + 1, r, (q - j + m) % m)) {
                res = f2_sol(l, i + 1, j) + "+" + f2_sol(i + 1, r, (q - j + m) % m);
                return 1;
            }
        }
    }
    return 0;
}

int solve() {
    int n, k, t;
    cin >> n >> k >> m >> t;
    ++k;
    allp = vector<vector<pii>>(m);
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            allp[i * j % m].puba({i, j});
        }
    }
    cin >> s;
    if (t == 1) {
        f1_mem.clear();
        vector<vector<vector<bool>>> d(k + 1, vector<vector<bool>>(m, vector<bool>(n + 1, 0)));
        vector<vector<vector<int>>> from(k + 1, vector<vector<int>>(m, vector<int>(n + 1)));
        for (int i = 0; i < m; ++i) {
            d[0][i][0] = 1;
        }
        for (int i = 0; i < n; ++i) {
            for (int j = i; j < n; ++j) {
                for (int q = 0; q < m; ++q) {
                    if (f1(i, j + 1, q)) {
                        for (int w = 0; w < k; ++w) {
                            if (d[w][q][i]) {
                                d[w + 1][q][j + 1] = 1;
                                from[w + 1][q][j + 1] = i;
                            }
                        }
                    }
                }
            }
        }
        int mem = -1;
        for (int i = 0; i < m; ++i) {
            if (d[k][i][n]) {
                mem = i;
                break;
            }
        }
        if (mem == -1) {
            cout << "Fail\n";
            return 0;
        }
        //cerr << "mem: " << mem << endl;
        int pos = n;
        vector<pii> segs;
        for (int i = 0; i < k; ++i) {
            segs.puba({from[k - i][mem][pos], pos});
            pos = from[k - i][mem][pos];
        }
        segs.back().ff = 0;
        reverse(bend(segs));
        for (int i = 0; i < k; ++i) {
            cout << f1_sol(segs[i].ff, segs[i].ss, mem);
            if (i < k - 1) {
                cout << "=";
            }
        }
        cout << "\n";
        return 0;
    }
    

    f2_mem.clear();
    f3_mem.clear();
    vector<vector<vector<bool>>> d(k + 1, vector<vector<bool>>(m, vector<bool>(n + 1, 0)));
    vector<vector<vector<int>>> from(k + 1, vector<vector<int>>(m, vector<int>(n + 1)));
    for (int i = 0; i < m; ++i) {
        d[0][i][0] = 1;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            for (int q = 0; q < m; ++q) {
                if (f2(i, j + 1, q)) {
                    for (int w = 0; w < k; ++w) {
                        if (d[w][q][i]) {
                            d[w + 1][q][j + 1] = 1;
                            from[w + 1][q][j + 1] = i;
                        }
                    }
                }
            }
        }
    }
    int mem = -1;
    for (int i = 0; i < m; ++i) {
        if (d[k][i][n]) {
            mem = i;
            break;
        }
    }
    if (mem == -1) {
        cout << "Fail\n";
        return 0;
    }
    //cerr << "mem: " << mem << endl;
    int pos = n;
    vector<pii> segs;
    for (int i = 0; i < k; ++i) {
        segs.puba({from[k - i][mem][pos], pos});
        pos = from[k - i][mem][pos];
    }
    segs.back().ff = 0;
    reverse(bend(segs));
    for (int i = 0; i < k; ++i) {
        cout << f2_sol(segs[i].ff, segs[i].ss, mem);
        if (i < k - 1) {
            cout << "=";
        }
    }
    cout << "\n";
    return 0;
}


int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    ios::sync_with_stdio(false);
    
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        solve();
    }
    
    
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}