#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 500, MAXW = 1000000000;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc >= 3);

    int k = atoi(argv[1]);
    int n = atoi(argv[2]);

    cout << n << " " << k << "\n";
    
    map<pii, int> where;
    
    for (int i = 0; i < n; ++i) {
        int lvl = rnd.next(1, k);
        int type = rnd.next(0, 3);
        if (where[{lvl, type}] == 2) {
            --i;
            continue;
        }
        where[{lvl, type}]++;
    }

    vector<pair<pii, pii>> outp;

    for (auto p : where) {
        vector<int> v1 = {0, p.ff.ff};
        shuffle(bend(v1));
        v1.resize(p.ss);
        sort(bend(v1));

        for (int i = 0; i < szof(v1); ++i) {
           int v2 = v1[i];
           if (!v2) {
                v2 = 1;
           }
           pair<pii, pii> e;
           if (p.ff.ss == 0) {
               e = {{p.ff.ff, v1[i] - p.ff.ff}, {p.ff.ff - 1, v2 - p.ff.ff}};
           } else if (p.ff.ss == 1) {
               e = {{-(v1[i] - p.ff.ff), p.ff.ff}, {-(v2 - p.ff.ff), p.ff.ff - 1}};
           } else if (p.ff.ss == 2) {
               e = {{-p.ff.ff, -(v1[i] - p.ff.ff)}, {-p.ff.ff + 1, -(v2 - p.ff.ff)}};
           } else {
               e = {{v1[i] - p.ff.ff, -p.ff.ff}, {v2 - p.ff.ff, -p.ff.ff + 1}};
           }         
           if (rnd.next(0, 1)) {
                swap(e.ff, e.ss);
           }
           outp.puba(e);
        }
    }

    shuffle(bend(outp));
    for (auto e : outp) {
        cout << e.ff.ff << " " << e.ff.ss << " " << e.ss.ff << " " << e.ss.ss << "\n";
    }

    int xa = rnd.next(1, k) * (rnd.next(0, 1) * 2 - 1);
    int ya = rnd.next(1, k) * (rnd.next(0, 1) * 2 - 1);
    int xb = rnd.next(1, k) * (rnd.next(0, 1) * 2 - 1);
    int yb = rnd.next(1, k) * (rnd.next(0, 1) * 2 - 1);

    cout << xa << " " << ya << " " << xb << " " << yb << "\n";

    return 0;
}