#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) (_x).begin(), (_x).end()
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
int MAXN = 100000, MAXC = 1000000000, MAXK = MAXC;

int sign(int num) {
    return num < 0 ? -1 : (num > 0 ? 1 : 0);
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    if (validator.group() == "1") {
        MAXN = 0;
        MAXK = 1000;
    } else if (validator.group() == "2") {
        MAXN = 500;
        MAXK = 30;
    } else if (validator.group() == "3") {
        MAXN = 500;
        MAXK = 200;
    } else if (validator.group() == "4") {
        MAXK = 50000;
    }

    int n = inf.readInt(0, MAXN, "n");
    inf.readSpace();
    int k = inf.readInt(1, MAXK, "k");
    inf.readEoln();

    map<int, vector<pii>> here[2];

    for (int i = 0; i < n; ++i) {
        int x1 = inf.readInt(-k, k, "x1");
        inf.readSpace();
        int y1 = inf.readInt(-k, k, "y1");
        inf.readSpace();
        int x2 = inf.readInt(-k, k, "x2");
        inf.readSpace();
        int y2 = inf.readInt(-k, k, "y2");

        inf.readEoln();
        ensuref(abs(max(abs(x1), abs(y1)) - max(abs(x2), abs(y2))) == 1, "segment should connect two neighbour squares");
        
        int k1 = max(abs(x1), abs(y1));
        int k2 = max(abs(x2), abs(y2));
        ensuref((x1 == k1 && x2 == k2) || (x1 == -k1 && x2 == -k2) || (y1 == k1 && y2 == k2) || (y1 == -k1 && y2 == -k2), "segment shouldn't intersect square");

        if (validator.group() == "2") {
            ensuref((x1 == 0 && y1 == 0) || (x2 == 0 && y2 == 0) || 
                    (y1 == 0 && y2 == 0) || (x1 == 0 && x2 == 0) || 
                    (abs(x1) == abs(y1) && abs(x2) == abs(y2) && sign(x1) == sign(x2) && sign(y1) == sign(y2)), 
                    "segment is bad");
        }

        if (abs(x1) == max(abs(x1), abs(y1)) && abs(x2) == max(abs(x2), abs(y2))) {
            if (x1 < x2) {
                here[0][x1].puba({y1, y2});
            } else {
                here[0][x2].puba({y2, y1});
            }
        }
        if (abs(y1) == max(abs(x1), abs(y1)) && abs(y2) == max(abs(x2), abs(y2))) {
            if (y1 < y2) {
                here[1][y1].puba({x1, x2});
            } else {
                here[1][y2].puba({x2, x1});
            }
        }
    }

    for (int i = 0; i < 2; ++i) {
        for (auto& p : here[i]) {
            sort(bend(p.ss));
            for (int j = 0; j < szof(p.ss) - 1; ++j) {
                ensuref(p.ss[j].ff < p.ss[j + 1].ff || p.ss[j].ss < p.ss[j + 1].ss, "segments shouldn't coincide");
                if (p.ss[j].ss > p.ss[j + 1].ss) {
                    ensuref(false, "segments shouldn't intersect");
                }
            }
        }
    }

    int xa = inf.readInt(-MAXC, MAXC, "xa");
    inf.readSpace();
    int ya = inf.readInt(-MAXC, MAXC, "ya");
    inf.readSpace();
    int xb = inf.readInt(-MAXC, MAXC, "xb");
    inf.readSpace();
    int yb = inf.readInt(-MAXC, MAXC, "yb");
    inf.readEoln();
    inf.readEof();

    return 0;
}